import sys
from pathlib import Path

import axipy
from axipy import AxiomaPlugin
from axipy.app import Notifications

from CatalogPointsNew.ui.DlgCatalogPoints import DlgCatalogPoints


class Plugin(AxiomaPlugin):
    def load(self):

        #super(Plugin, self).__init__()

        menubar = self.menubar
        tr = self.tr
        local_file=self.local_file
        self.__action = menubar.create_button(self.tr('Каталог точек'),
                                              icon=local_file('ui/icons', 'catalog_points.png'), on_click=self.run_tools)
        #position = menubar.get_position(tr('Таблица'), tr('Действие Операции'))
        position = menubar.get_position(tr('Таблица'), tr('Действие'))
        position.add(self.__action, size=2)
        #print("Get catalog")
        self.__catalog=axipy.app.mainwindow.catalog
        if self.__catalog is None:
            print("axipy.app.mainwindow.catalog is None")
        self.__selection=axipy.gui.selection_manager
        path_user_data=self.user_plugin_data_dir()
        #print("Get catalog 1")
        self.__catalog.updated.connect(self.__tryInReady)
        #print("Get catalog 2")
        self.__tryInReady()
        #self.__selection.changed.connect(self.__changeSelection)
    def unload(self):
        self.__catalog.updated.disconnect(self.__tryInReady)
        #self.__viewService.countChanged.disconnect(self.__tyrIsReadyForMapAndSelection)
        self.menubar.remove(self.__action)
    def run_tools(self):

        main = DlgCatalogPoints(None, axipy.app.mainwindow.qt_object())
        main.show()

    def __changeSelection(self):
        print("run select")
    def __tryInReady(self):
        '''
        Проверяем условия для готовности инструмента к работе
        Должна быть открыта хотя бы одна пространственная таблица
        :return:
        '''
        tables=self.__catalog.tables
        for table in tables:
            if table.is_spatial and table.count()>0:
                self.__action.action.setEnabled(True)
                return

        self.__action.action.setEnabled(False)