import os

from PySide2.QtGui import Qt
from PySide2.QtWidgets import QWidget, QDialog

from CatalogPointsNew.ui.utils.ui_tools import load_ui, textToBool


class DlgAngle(QDialog):
    def __init__(self,json_params,parent=None):
        super(DlgAngle, self).__init__(parent)
        self.__isOk=False
        self.__def_params=json_params
        self.__list_formats=['dd.zz','dd°mm’ss.zz','ЮВ dd.zz']
        #path_ui = os.path.join(os.path.dirname(__file__), "WidgetCoords.ui")
        path = os.path.join(os.path.dirname(__file__), "DlgAngle.ui")
        self.window=load_ui(path,parent)
        self.window.setWindowFlag(Qt.WindowContextHelpButtonHint, False)
        self.window.pb_ok.clicked.connect(self.__ok)
        self.window.pb_cancel.clicked.connect(self.__cancel)
        self.__params_out=json_params
        self.__method_calc = ['на сфере', 'на плоскости']
        self.__initParams()
    def __initParams(self):
        self.window.ln_name_field.setText(self.__def_params['name_field'])

        self.window.cmb_format.insertItems(0, self.__list_formats)

        curent_format = self.__list_formats.index(self.__def_params['format'])
        if curent_format is not None:
            self.window.cmb_format.setCurrentIndex(curent_format)
        self.window.spin_decimal.setValue(int(self.__def_params['decimal']))
        self.window.cmb_method_calc_distance.insertItems(0, self.__method_calc)
        isShere = textToBool(self.__def_params['method_calc_shere'])
        # index_calc=self.__method_calc.index(self.__def_params['method_calc'])
        index_calc = 1
        if isShere:
            index_calc = 0
        self.window.cmb_method_calc_distance.setCurrentIndex(index_calc)
    def __ok(self):
        self.__isOk=True
        self.__create_out_params()
        self.window.close()

    def __cancel(self):
        self.__isOk = False
        self.window.close()

    def __create_out_params(self):
        self.__params_out = {}
        self.__params_out['name_field'] = self.window.ln_name_field.text().strip()

        #self.__params_out['unit'] = self.window.cmb_units.currentText()
        self.__params_out['format'] = self.window.cmb_format.currentText()
        self.__params_out['decimal'] = self.window.spin_decimal.value()
        idmethod_calc=self.window.cmb_method_calc_distance.currentIndex()
        self.__params_out['method_calc_shere']="False"
        if idmethod_calc==0:
            self.__params_out['method_calc_shere'] = "True"
    @property
    def IsOk(self):
        return self.__isOk
    def show(self):
        self.window.show()
    @property
    def isRequired(self):
        return True
    @property
    def Name(self):
        return "Азимут"

    @property
    def params(self):
        return self.__params_out