import os

from PySide2.QtGui import Qt
from PySide2.QtWidgets import QWidget, QDialog

from CatalogPointsNew.ui.utils.ui_tools import load_ui


class DlgCoords(QDialog):
    def __init__(self,json_params,parent=None):
        super(DlgCoords, self).__init__(parent)
        self.__isOk=False
        self.__def_params=json_params
        self.__cs=None
        #self.__list_formats=['dd.zz','dd°mm’ss.zz','dd°mm’ss".zz','dd mm ss.zz','dd/mm/ss.zz','dd-mm-ss.zz']
        self.__list_formats = ['dd.zz', 'dd°mm’ss.zz', 'dd mm ss.zz', 'dd/mm/ss.zz', 'dd-mm-ss.zz']
        #path_ui = os.path.join(os.path.dirname(__file__), "WidgetCoords.ui")
        path = os.path.join(os.path.dirname(__file__), "DlgCoords.ui")
        self.window=load_ui(path,parent)
        self.__initParams()
        #self.window.setWindowFlag(Qt.WindowCloseButtonHint, False)
        self.window.setWindowFlag(Qt.WindowContextHelpButtonHint,False)
        self.window.pb_ok.clicked.connect(self.__ok)
        self.window.pb_cancel.clicked.connect(self.__cancel)
        self.__params_out=json_params
    def __initParams(self):
        self.window.ln_name_x.setText(self.__def_params['name_field_x'])
        self.window.ln_name_y.setText(self.__def_params['name_field_y'])
        self.window.cmb_format.insertItems(0,self.__list_formats)
        curent_format=self.__list_formats.index(self.__def_params['format'])
        if curent_format is not None:
            self.window.cmb_format.setCurrentIndex(curent_format)
        self.window.spin_decimal.setValue(int(self.__def_params['decimal']))
    def __ok(self):
        self.__isOk=True
        self.__create_out_params()
        self.window.close()

    def __cancel(self):
        self.__isOk = False
        self.window.close()
    @property
    def IsOk(self):
        return self.__isOk
    def show(self):
        self.window.show()
    @property
    def isRequired(self):
        return True
    @property
    def Name(self):
        return "Координаты точек"
    def __create_out_params(self):
        self.__params_out = {}
        self.__params_out['name_field_x'] = self.window.ln_name_x.text().strip()
        self.__params_out['name_field_y'] = self.window.ln_name_y.text().strip()
        self.__params_out['format'] = self.window.cmb_format.currentText()
        #self.__params_out['method_calc'] = self.window.cmb_method_calc_distance.currentText()
        self.__params_out['decimal'] = self.window.spin_decimal.value()
        self.__params_out["reverse_xy"]="False"

    @property
    def params(self):

        return self.__params_out
    def setCoordSystem(self,new_cs):
        self.__cs=new_cs
