import os

from PySide2.QtGui import Qt
from PySide2.QtWidgets import QWidget, QDialog

from CatalogPointsNew.ui.utils.ui_tools import load_ui, textToBool


class DlgDistance(QDialog):
    def __init__(self,json_params,parent=None):
        super(DlgDistance, self).__init__(parent)
        self.__isOk=False
        self.__cs=None
        #path_ui = os.path.join(os.path.dirname(__file__), "WidgetCoords.ui")
        path = os.path.join(os.path.dirname(__file__), "DlgDistance.ui")
        self.window=load_ui(path,parent)
        self.__def_params = json_params
        self.__units=['м','км']
        self.__method_calc=['на сфере','на плоскости']
        self.__initParams()
        self.window.setWindowFlag(Qt.WindowContextHelpButtonHint, False)
        self.window.pb_ok.clicked.connect(self.__ok)
        self.window.pb_cancel.clicked.connect(self.__cancel)
        self.__params_out = json_params
    def __initParams(self):
        self.window.ln_name_field.setText(self.__def_params['name_field'])
        self.window.cmb_units.insertItems(0,self.__units)
        self.window.cmb_method_calc_distance.insertItems(0, self.__method_calc)

        curent_format = self.__units.index(self.__def_params['unit'])
        if curent_format is not None:
            self.window.cmb_units.setCurrentIndex(curent_format)
        isShere=textToBool(self.__def_params['method_calc_shere'])
        #index_calc=self.__method_calc.index(self.__def_params['method_calc'])
        index_calc=1
        if isShere:
            index_calc=0
        self.window.cmb_method_calc_distance.setCurrentIndex(index_calc)
        self.window.spin_decimal.setValue(int(self.__def_params['decimal']))

    def __ok(self):
        self.__isOk = True
        self.__create_out_params()
        self.window.close()


    def __cancel(self):
        self.__isOk = False
        self.window.close()


    @property
    def IsOk(self):
        return self.__isOk


    def show(self):
        self.window.show()


    @property
    def isRequired(self):
        return True

    def __create_out_params(self):
        self.__params_out = {}
        self.__params_out['name_field'] = self.window.ln_name_field.text().strip()
        self.__params_out['unit'] = self.window.cmb_units.currentText()
        indexMethod=self.window.cmb_method_calc_distance.currentIndex()
        strMethodShpere="False"
        if indexMethod==0:
            strMethodShpere = "True"
        self.__params_out['method_calc_shere'] = strMethodShpere
        self.__params_out['decimal'] = self.window.spin_decimal.value()
    @property
    def Name(self):
        return "Длина"
    @property
    def params(self):

        return self.__params_out

    def setCoordSystem(self, new_cs):
        self.__cs = new_cs


