import os

from PySide2.QtGui import Qt
from PySide2.QtWidgets import QWidget, QDialog

from CatalogPointsNew.ui.utils.ui_tools import load_ui, textToBool


class DlgIdPoints(QDialog):
    def __init__(self,json_params,parent=None):
        super(DlgIdPoints, self).__init__(parent)
        self.__isOk=False
        #path_ui = os.path.join(os.path.dirname(__file__), "WidgetCoords.ui")
        path = os.path.join(os.path.dirname(__file__), "DlgIdPoint_1.ui")
        self.window=load_ui(path,parent)
        self.window.ln_name_id.setText(json_params['name_field'])
        self.window.ln_start.setText(str(json_params['start_value']))
        self.window.spin_step.setValue(int(json_params['step']))

        self.window.chb_continue.setChecked(textToBool(json_params['numeration_continue']))
        is_topo=True

        self.window.chb_topo.setEnabled(textToBool(json_params['numeration_continue']))
        try:
            str_is_topo=json_params['topology']
            is_topo=textToBool(str_is_topo)
        except:
            pass
        self.window.chb_topo.setChecked(is_topo)
        #self.window.setWindowFlag(Qt.WindowCloseButtonHint, False)
        self.window.setWindowFlag(Qt.WindowContextHelpButtonHint,False)
        self.window.chb_continue.stateChanged.connect(self.__click_ch_continius)
        self.window.pb_ok.clicked.connect(self.__ok)
        self.window.pb_cancel.clicked.connect(self.__cancel)
        self.__params_out=json_params
        self.__create_out_params()
    def __ok(self):
        self.__isOk=True
        self.__create_out_params()
        self.window.close()
    def __click_ch_continius(self):
        self.window.chb_topo.setEnabled(self.window.chb_continue.isChecked())

    def __cancel(self):
        self.__isOk = False

        self.window.close()
    @property
    def IsOk(self):
        return self.__isOk
    def show(self):
        self.window.show()
    @property
    def isRequired(self):
        return True

    @property
    def Name(self):
        return "Номера точек"
    def __create_out_params(self):
        self.__params_out = {}
        self.__params_out['name_field'] = self.window.ln_name_id.text().strip()
        self.__params_out['start_value'] = int(self.window.ln_start.text().strip())
        self.__params_out['step'] = self.window.spin_step.value()
        self.__params_out['numeration_continue'] = "False"
        self.__params_out['topology'] = "False"
        if self.window.chb_continue.isChecked():
            self.__params_out['numeration_continue'] = "True"
            if self.window.chb_topo.isChecked():
                self.__params_out['topology'] = "True"
    @property
    def params(self):


        return self.__params_out

