import os

from PySide2.QtCore import Qt
from PySide2.QtWidgets import QDialog

from CatalogPointsNew.ui.utils.ui_tools import load_ui, textToBool


class DlgReferenceField(QDialog):
    def __init__(self,json_params,parent=None):
        super(DlgReferenceField, self).__init__(parent)
        self.__isOk=False
        self.__def_params=json_params
        path_ui = os.path.join(os.path.dirname(__file__), "DlgRelativeField.ui")
        self.window = load_ui(path_ui, parent)
        self.window.setWindowFlag(Qt.WindowContextHelpButtonHint, False)
        self.window.pb_ok.clicked.connect(self.__ok)
        self.window.pb_cancel.clicked.connect(self.__cancel)
        self.__initParams()
        self.__create_out_params()
    def __initParams(self):
        self.window.ln_name_field.setText(self.__def_params['name_field'])
        self.__curent_id_field=self.__def_params['index_field']
        self.window.ch_in_first_only.setChecked(textToBool(self.__def_params['value_in_start_field']))
    def setCurentTable(self,table):
        self.__curentTable=table
        self.__updateCmbFieldName()
        self.__create_out_params()
    def __updateCmbFieldName(self):
        self.window.cmb_field_parent.clear()
        for name_field in self.__curentTable.schema.attribute_names:
            self.window.cmb_field_parent.addItem(name_field)
        self.window.cmb_field_parent.setCurrentIndex(self.__curent_id_field)

    @property
    def IsOk(self):
        return self.__isOk

    def __cancel(self):
        self.__isOk = False
        self.window.close()

    def show(self):
        self.window.show()

    @property
    def isRequired(self):
        return True

    @property
    def Name(self):
        return "Поле исходной таблицы"
    def __create_out_params(self):
        self.__params_out = {}
        self.__params_out['name_field'] = self.window.ln_name_field.text().strip()
        self.__params_out['index_field'] = self.window.cmb_field_parent.currentIndex()

        self.__params_out['value_in_start_field'] = "False"
        if self.window.ch_in_first_only.isChecked():
            self.__params_out['value_in_start_field'] = "True"
    def __ok(self):
        self.__isOk=True
        self.__create_out_params()
        self.window.close()


    @property
    def params(self):
        return self.__params_out