import os
from pathlib import Path

import PySide2
from PySide2 import QtCore
from PySide2.QtGui import QIcon
from PySide2.QtWidgets import QDialog, QListWidgetItem, QWidget, QLabel, QPushButton, QHBoxLayout, QToolButton, \
    QCheckBox
from PySide2.QtCore import Qt

from CatalogPointsNew.ui.DlgCoords import DlgCoords
from CatalogPointsNew.ui.WCoords import WidgetCoords
from CatalogPointsNew.ui.WidPoint import WidgetIdPoint
from CatalogPointsNew.ui.utils.ui_tools import load_ui


class DlgTestList(QDialog):
    def __init__(self,parent=None):
        super(DlgTestList, self).__init__(parent)
        path_ui=os.path.join(os.path.dirname(__file__), "DialogListProperty.ui")
        self.window = load_ui(path_ui,parent)
        curent_path = str(Path(__file__).parent)
        self.__path_icon = os.path.join(curent_path, "icons")
        self.window.tb_add.setIcon(QIcon( os.path.join(self.__path_icon, "add.png")))
        self.window.tb_del.setIcon(QIcon(os.path.join(self.__path_icon, "del.png")))
        self.__initView()
        self.window.list_out_items.setCurrentRow(0)
        self.window.tb_del.clicked.connect(self.__disable_item)
    def __initView(self):
        w_idPoint = WidgetIdPoint(self.window)
        self.__addWidget(w_idPoint)
        self.__w_coord=DlgCoords(self.window)
        self.__addWidget(self.__w_coord)
    def __addWidget(self,widget):
        '''
        item = QListWidgetItem()
        item_widget = QWidget()
        line_chekBox=QCheckBox()
        #line_chekBox.setCheckState(True)
        line_text = QLabel(widget.Name)
        #if not widget.isRequired:
        line_push_button = QToolButton()

        path_add_png = os.path.join(self.__path_icon, "config4.png")

        line_push_button.setIcon(QIcon(path_add_png))
        line_push_button.setObjectName(widget.Name)
        line_push_button.clicked.connect(self.clicked)
        item_layout = QHBoxLayout()
        item_layout.addWidget(line_chekBox)
        item_layout.addWidget(line_text)
        #if not widget.isRequired:
        item_layout.addWidget(line_push_button)
        item_widget.setLayout(item_layout)
        item.setSizeHint(item_widget.sizeHint())
        #item.setFlags(item.flags() |QtCore.Qt.ItemIsUserCheckable)
        #item.setCheckState(Qt.Unchecked)
        '''
        item, item_widget=self.__createItem(widget)
        self.window.list_out_items.addItem(item)
        self.window.list_out_items.setItemWidget(item, item_widget)
    def __disable_item(self):
        curent_item= self.window.list_out_items.currentItem()
        #self.window.list_out_items.currentItem().setFlags(Qt.NoItemFlags)
    def clicked(self):
        sender = self.sender()
        push_button = self.window.findChild(QToolButton, sender.objectName())
        print(f'click: {push_button.objectName()}')
        self.__w_coord.window.setWindowFlag(Qt.WindowSystemMenuHint,on=False)
        self.__w_coord.window.exec_()
    def __createItem(self,widget):
        item = QListWidgetItem()
        item_widget = QWidget()
        line_chekBox = QCheckBox()
        # line_chekBox.setCheckState(True)
        line_text = QLabel(widget.Name)
        # if not widget.isRequired:
        line_push_button = QToolButton()

        path_add_png = os.path.join(self.__path_icon, "config4.png")

        line_push_button.setIcon(QIcon(path_add_png))
        line_push_button.setObjectName(widget.Name)
        line_push_button.clicked.connect(self.clicked)
        item_layout = QHBoxLayout()
        item_layout.addWidget(line_chekBox)
        item_layout.addWidget(line_text)
        item_layout.addWidget(line_push_button)
        item_widget.setLayout(item_layout)
        item.setSizeHint(item_widget.sizeHint())
        return item,item_widget
    def show(self):
        self.window.show()
