import os

from PySide2 import QtCore
from PySide2.QtCore import QThread
from PySide2.QtWidgets import QDialog, QApplication

from CatalogPointsNew.ui.tools.buildCatalogPoints import BuilderCatalogPoints
from CatalogPointsNew.ui.utils.ui_tools import load_ui


class DlgRunPrigress(QDialog):
    cancelProcess = QtCore.Signal()
    def __init__(self, title,parent=None):
        super(DlgRunPrigress, self).__init__(parent)
        path_ui = os.path.join(os.path.dirname(__file__), "DlgProgressProcess.ui")
        self.window = load_ui(path_ui)
        self.window.setWindowTitle(title)
        self.window.setModal(True)
    def __end_process(self, value):
        #self.window.pb_cancel.setEnabled(False)

        if value == 100:
            pass
        else:
            '''
            if os.path.exists(self.__path_out_raster):
                os.remove(self.__path_out_raster)
            Notifications.push('Объединение растров', 'Было преррвано', Notifications.Information)
            '''
            pass
        self.__process=None
        self.window.close()
    def __update_progress(self, value):
        self.window.pr_bar_process.setValue(value)

        # print(value)
        import time
        time.sleep(0.0001)
        QApplication.processEvents()
    def __setFormatprogressBar(self, str_format):
        self.window.pr_bar_process.setFormat(str_format)
        import time
        time.sleep(0.0001)
        QApplication.processEvents()
    def __run(self,params):
        self.__process = BuilderCatalogPoints(self)
        self.__process.setParams(params)

        self.__process.updateProcess.connect(self.__update_progress)
        self.__process.finished.connect(self.__end_process)
        self.__process.updateFormatProgressBar.connect(self.__setFormatprogressBar)
        self.thread = QThread()
        self.__process.moveToThread(self.thread)
        self.__process.run()
    def exec_(self,params):

        self.window.pr_bar_process.setValue(0)
        self.window.show()
        self.__run(params)
        self.window.exec_()
        self.window.close()
    def show(self,params):
        self.window.pr_bar_process.setValue(0)
        self.window.show()
        self.__run(params)


