import importlib
import os
from pathlib import Path
from  axipy import *

from .psevdoFeature import SimpleFeature
from .recordTools import ClsItemId
#from CatalogPointsNew.ui.tools.recordTools import ItemId, ItemCoordPoints
from CatalogPointsNew.ui.utils.ui_tools import textToBool

def FeatureClone(ft:Feature,new_geometry=None):
    attr_temp=ft.items()
    attr= {}
    for att in attr_temp:
        if att[0]=='+geometry' or att[0]=='+style':
            continue
        attr[att[0]]=att[1]
    if new_geometry is not None:
        return Feature(attr, geometry=new_geometry, style=ft.style)
    new_geo=None
    if ft.geometry is not None:
        new_geo=ft.geometry.clone()
    return Feature(attr,geometry=new_geo,style=ft.style)
class CatalogRecords:
    def __init__(self,params,source_tab):
        self.__source_tab=source_tab
        self.__params_control=params
        self.__controls=None
        self.__idTopology = False
        self.__nameId = None
        self.__nameX=None
        self.__nameY=None
        self.factory(params)

    def factory(self,params):

        dir_path = os.path.dirname(os.path.realpath(__file__))
        module_name=__name__

        parent_folder = Path(__file__).parent
        #path_module = (str(parent_folder) + "." + 'recordTools')
        #path_module=path_module.replace("\\",'.')
        path_module=module_name.replace('recordCatalog','recordTools')
        module = importlib.import_module(path_module)
        self.__controls=[]

        for item in params['template_params']['widget']:
            if not textToBool(item['active']):
                continue
            if item['name'].lower()=='idpoints':
                try:
                    self.__idTopology=textToBool(item['params']['topology'])
                    self.__nameId=item['params']['name_field']
                except:
                    pass
            if item['name'].lower()=='coords_points':
                self.__nameX=item['params']['name_field_x']
                self.__nameY = item['params']['name_field_y']
            '''
            if item['name'].lower()=='idpoints':
                self.__controls.append(ItemId(item['params']))
                continue
            if item['name'].lower()=='coords_points':
                self.__controls.append(ItemCoordPoints(item['params']))
                continue
            '''
            try:
                name_cls=item['name_cls']
                cur_cls=getattr(module, name_cls)
                #cur_cls.initCls(item['params'])
                self.__controls.append(cur_cls(item['params']))
                self.__controls[-1].setAttSourceField(self.__source_tab.schema)
            except Exception as ex:
                continue
    @property
    def IsTopology(self):
        return self.__idTopology,self.__nameId,self.__nameX,self.__nameY
    @property
    def structura(self):
        list_field=[]
        for item in self.__controls:
            property_field=item.fieldDescriptions()
            list_field.extend(property_field)
        return list_field
    def start(self):
        self.__id_object=0
    def __catPointsSimpleObjectNew(self,ft):
        if ft.geometry.type == GeometryType.Point or ft.geometry.type == GeometryType.Arc or ft.geometry.type == GeometryType.Ellipse or ft.geometry.type == GeometryType.Text:
            return
        if not isinstance(ft.geometry,Polygon):
            return self.__catPointsSimpleObject(ft)
        holes=ft.geometry.holes
        if len(holes)==0:
            return self.__catPointsSimpleObject(ft)
        list_simple_ft=self.__catPointsSimpleObject(ft)
        for hole in holes:
            temp_poly_hole=Polygon(hole,cs=ft.geometry.coordsystem)
            ft_temp=FeatureClone(ft,temp_poly_hole)
            list_simple_ft.extend(self.__catPointsSimpleObject(ft_temp))
        return list_simple_ft
    def __catPointsSimpleObject(self,ft):
        if ft.geometry.type == GeometryType.Point or ft.geometry.type == GeometryType.Arc or ft.geometry.type == GeometryType.Ellipse or ft.geometry.type == GeometryType.Text:
            return

        list_data_ft=[]
        #if ft.geometry.type == GeometryType.Line:
        row_data=[]
        points=ft.geometry.points
        cnt_points=len(ft.geometry.points)
        pt1 = points[0]
        geo_point1 = Point(pt1.x,pt1.y,ft.geometry.coordsystem)
        ft_1 = SimpleFeature(ft.items(),geo_point1,True)

        for i in range (cnt_points-1):

            pt2=points[i+1]

            geo_point2 = Point(pt2.x, pt2.y,ft.geometry.coordsystem)

            ft_2 =  SimpleFeature(ft.items(),geo_point2)

            row_data = []
            for plugin_cnt in self.__controls:
                result=plugin_cnt.value([ft_1,ft_2])
                if result is not None:
                    '''
                    temp_value={}
                    for item_res in result:
                        temp_value[item_res['name']]=item_res['value']
                    '''
                    row_data.extend(result)
                    #row_data.extend(temp_value)

            ft_1=ft_2
            list_data_ft.append(row_data)
        if not (ft.geometry.type==GeometryType.Polygon):
            ''' Если полигон пропускаем последнию точку '''
            row_data = []
            for plugin_cnt in self.__controls:
                result = plugin_cnt.value([ft_1, None])
                if result is not None:
                    row_data.extend(result)


            list_data_ft.append(row_data)
        return list_data_ft

    def catalogPoints(self,ft):
        for itwm_widgwt in self.__controls:
            try:
                itwm_widgwt.start_start_feature()
            except:
                pass
        geometry=ft.geometry
        if geometry.type==GeometryType.Point or geometry.type==GeometryType.MultiPoint:
            return
        if geometry.type==GeometryType.GeometryCollection or geometry.type==GeometryType.MultiPolygon or geometry.type==GeometryType.MultiLineString:
            point_collection=[]
            for simple_geo in geometry:
                #ft_simple=ft.clone()
                ft_simple=FeatureClone(ft)
                ft_simple.geometry=simple_geo
                points_data=self.__catPointsSimpleObject(ft_simple)
                if points_data is not None:
                    point_collection.extend(points_data)
            if len(point_collection)<=0:
                return None
            return point_collection
        else:
            return self.__catPointsSimpleObjectNew(ft)
            #return self.__catPointsSimpleObject(ft)
        
