import abc

import axipy
from axipy import  Geometry, Pnt, AngleCoord

from CatalogPointsNew.ui.utils.ui_tools import textToBool


class BaseItemRecord(metaclass=abc.ABCMeta):
   @abc.abstractmethod
   def initCls(self,json_params):
       pass

   @property
   @abc.abstractmethod
   def NameItem(self):
       pass

   @property
   @abc.abstractmethod
   def Name(self):
       pass

   @property
   @abc.abstractmethod
   def value(self,params):
       pass

   @property
   @abc.abstractmethod
   def fieldDescriptions(self):
       pass


   @abc.abstractmethod
   def start(self, json_params):
       pass
class ClsReferenceId(BaseItemRecord):
    def __init__(self,json_params=None):
        self.__curent_value=None
        if json_params is None:
            return
        self.initCls(json_params)
    def initCls(self,json_params):
        try:
            self.__name_field=json_params['name_field']
            self.__id_ref_field = json_params['index_field']
            self.__value_in_start_field=textToBool(json_params['value_in_start_field'])
        except:
            pass
    def NameItem(self):
        return self.__nameField

    def fieldDescriptions(self):
        pass
    def setAttSourceField(self,source_shema):
        self.__att_source=source_shema[self.__id_ref_field]

    def Name(self):
        return "ItemId"
    def start(self):
        pass
    def value(self,params):
        try:
            cur_value=params[0].att[self.__id_ref_field]
            result_value={"name": self.__name_field, 'value': cur_value[1]}
            return [result_value]
        except:
            return None
    def fieldDescriptions(self):
        field_description = {}
        field_description['name'] = self.__name_field
        field_description['type'] = self.__att_source.type_string
        field_description['size'] = self.__att_source.length
        return [field_description]
class ClsItemId(BaseItemRecord):
    def __init__(self,json_params=None):
        self.__curent_value=None
        if json_params is None:
            return
        self.initCls(json_params)
    def initCls(self,json_params):
        try:
            self.__nameField=json_params['name_field']
            self.__type="int"
            self.__start_value=json_params['start_value']
            self.__step=json_params['step']
            self.__numeration_continue=textToBool(json_params['numeration_continue'])
        except:
            return False

    def NameItem(self):
        return self.__nameField

    def Name(self):
        return "ItemId"

    def value(self, params):
        ret_value=[{'name': self.__nameField, 'value': self.__curent_value}]
        self.__curent_value=self.__curent_value+self.__step
        return ret_value
    def start(self, json_params):
        if self.__numeration_continue and self.__curent_value==self.__start_value:
            return
        self.__curent_value=self.__start_value
    def start_start_feature(self):
        if self.__curent_value is None:
            self.__curent_value = self.__start_value
            return
        if self.__numeration_continue and not(self.__curent_value==self.__start_value):
            return
        self.__curent_value=self.__start_value
    def fieldDescriptions(self):
        field_description={}
        field_description['name']=self.__nameField
        field_description['type'] = self.__type
        field_description['size'] = 0
        return [field_description]
def getValueToFormat(value,format,decimal):

    if format == 'dd.zz':
        return round(value, decimal)
    #anglFloatCoord=axipy.FloatCoord(value)
    angFrmCls = AngleCoord(value)
    #angFrmCls=AngleCoord.from_float(value)

    #grad, min, sec =AngleCoord().split_degree(value)
    grad=angFrmCls.degrees
    min=angFrmCls.minutes
    sec=angFrmCls.seconds
    if format == 'dd°mm’ss.zz':
        out_value = str(grad) + '°' + str(min) + '’' + str(round(sec,decimal))
        return out_value
    if format == 'dd mm ss.zz':
        out_value = str(grad) + ' ' + str(min) + ' ' + str(round(sec,decimal))
        return out_value
    if format == 'dd/mm/ss.zz':
        out_value = str(grad) + '/' + str(min) + '/' + str(round(sec,decimal))
        return out_value
    if format == 'dd-mm-ss.zz':
        out_value = str(grad) + '-' + str(min) + '-' + str(round(sec,decimal))
        return out_value
    if format=='ЮВ dd.zz':
        ''' Углы в румбах'''
        #out_value=AngleCoord().double_to_rumb(value,decimal)
        out_value=angFrmCls.as_rumb()
        return out_value
    return None
def getCoordForPoint(value,format,decimal):
    if format == 'dd.zz':
        return round(value, decimal)
    #grad, min, sec = AngleCoord().split_degree(value)
    #angCls= AngleCoord.from_float(value)
    angCls = AngleCoord(value)
    grad=angCls.degrees
    min=angCls.minutes
    sec=angCls.seconds
    str_format="{grad:d} {min:d} "+"{sec:."+str(decimal)+"f}"
    str_value=str_format.format(grad=grad,min=min,sec=sec)
    #value_out=AngleCoord().as_float(str_value)
    #value_out=AngleCoord.from_string(str_value)
    value_out = AngleCoord(str_value)
    #return value_out.as_float()
    return value_out.value
class ClsItemCoordPoints(BaseItemRecord):
    def __init__(self,json_params=None):
        if json_params is None:
            return
        self.initCls(json_params)
    def initCls(self,json_params):
        try:
            self.__nameField_x=json_params['name_field_x']
            self.__nameField_y = json_params['name_field_y']
            self.__format=json_params["format"]
            self.__decimal=json_params['decimal']
            self.__reverse_xy=textToBool(json_params['reverse_xy'])
            self.__method_on_shere=textToBool(json_params['method_calc_shere'])
        except:
            return False

    def NameItem(self):
        return self.__nameField_x,self.__nameField_y

    def Name(self):
        return "ItemCoordPoints"

    def value(self, params):

        point=params[0].geometry
        x=getValueToFormat(point.x,self.__format,self.__decimal)
        y = getValueToFormat(point.y, self.__format, self.__decimal)
        item_x={"name":self.__nameField_x,'value':x}
        item_y = {"name": self.__nameField_y, 'value': y}
        x_geo=getCoordForPoint(point.x,self.__format,self.__decimal)
        y_geo = getCoordForPoint(point.y, self.__format, self.__decimal)
        pnt=Pnt(x_geo,y_geo)
        geometry={"name":'geometry$$$','value':pnt}
        if self.__reverse_xy:
            return [item_y,item_x,geometry]
        return [item_x,item_y,geometry]
    def fieldDescriptions(self):
        field_description_x={}
        field_description_x['name']=self.__nameField_x
        if self.__format=='dd.zz':
            field_description_x['type'] = "float"
        else:
            field_description_x['type'] = "str"
            field_description_x['size']=20
        field_description_y= field_description_x.copy()
        field_description_y['name']=self.__nameField_y
        return [field_description_x,field_description_y]

    def start(self, json_params):
        pass
class ClsItemAnglePoints(BaseItemRecord):
    def __init__(self,json_params=None):
        if json_params is None:
            return
        self.initCls(json_params)
    def initCls(self,json_params):
        try:
            self.__nameField=json_params['name_field']

            self.__format=json_params["format"]
            self.__decimal=json_params['decimal']
            self.__method_on_shere=textToBool(json_params['method_calc_shere'])



        except:
            return False
    def fieldDescriptions(self):
        field_description={}
        field_description['name'] = self.__nameField
        if self.__format == 'dd.zz':
            field_description['type'] = "float"
        else:
            field_description['type'] = "str"
            field_description['size'] = 20
        return [field_description]
    def NameItem(self):
        return self.__nameField

    def Name(self):
        return "ItemAnglePoints"
    def start(self, json_params):
        pass

    def value(self, params):
        if len(params)<=1 or params[1] is None:
            return None
        point_1 = params[0].geometry
        point_2 = params[1].geometry
        cs=None
        if self.__method_on_shere:
            cs=point_1.coordsystem
        if params[0].isStartPoint:
            dist_m=0
            angle=0
        else:
            dist_m,angle=Geometry.distance_by_points((point_1.x,point_1.y),(point_2.x,point_2.y),cs)
        angle_out=getValueToFormat(angle,self.__format,self.__decimal)
        return [{'name':self.__nameField,'value':angle_out}]
class ClsItemDistancePoints(BaseItemRecord):
    def __init__(self,json_params=None):
        if json_params is None:
            return
        self.initCls(json_params)
    def initCls(self,json_params):
        try:
            self.__nameField=json_params['name_field']

            #self.__format=json_params["format"]
            self.__decimal=json_params['decimal']
            self.__unit = json_params['unit']
            self.__method_on_shere=textToBool(json_params['method_calc_shere'])



        except:
            return False
    def fieldDescriptions(self):
        field_description={}
        field_description['name'] = self.__nameField
        field_description['type'] = "float"

        return [field_description]
    def NameItem(self):
        return self.__nameField

    def Name(self):
        return "ItemDistancePoints"
    def start(self, json_params):
        pass

    def value(self, params):
        if len(params)<=1 or params[1] is None:
            return None
        point_1 = params[0].geometry
        point_2 = params[1].geometry
        cs=None
        if self.__method_on_shere:
            cs=point_1.coordsystem
        if params[0].isStartPoint:
            dist_m=0
            angle=0
        else:
            dist_m,angle=Geometry.distance_by_points((point_1.x,point_1.y),(point_2.x,point_2.y),cs)

        #angle_out=getValueToFormat(angle,self.__format,self.__decimal)
        if self.__unit=='км':
            dist_m=dist_m/1000.
        dist_out=round(dist_m,self.__decimal)
        return [{'name':self.__nameField,'value':dist_out}]






